# Sixteenth International Obfuscated C Code Contest


## Standard IOCCC stuff

View the `index.html` web page for the given winning entry for information on how
on how to compile it and how to run the winning program.
Look at the winning source and try to figure how it does what it does!
You may then wish to look at the Author's remarks for even more details.


Some ANSI C compilers are not quite as good as they should be.  If
yours is lacking, you may need to compile using gcc instead of your
local compiler.


### Historical note:

The IOCCC has a website and now has a number of international mirrors.
The primary website can be found at [www.ioccc.org](https://www.ioccc.org).


### Historical update:

The IOCCC website once had a number of
[international mirrors](https://web.archive.org/web/20201030210517/https://www.ioccc.org/mirror.html).
As of 2020 Dec 29, [GitHub](https://www.github.com) serves as the distributed server farm for the
[IOCCC winner repo](https://github.com/ioccc-src/winner) that GitHub renders as
[Official IOCCC website - www.ioccc.org](https://www.ioccc.org).


## Remarks on some of the entries

There were some outstanding entries that did not win.  Unfortunately
some very good entries lost because they:

- depended too much on non-portable side effects in expressions;
- depended too much on a particular byte order;
- required the use of a special script, data file or pseudo-machine
  language that was not supplied with the entry.

We hope the authors of some of those entries will fix and re-submit
them for the next IOCCC.

We believe you will be impressed with this year's winning entries  The [Best of
Show](ollinger/index.html) is a fine example of obfuscation.  But don't ignore
the other entries!  There are games, programs that speak, ones that compile code
and [one that _might_ run binaries you already have](anonymous/index.html).

The [Best abuse of the rules](bellard/index.html) is technically allowed by the
[rules](rules.txt).  This year we awarded it again, but don't assume you can get
away with using the same technique next time ... :-)

This year there were several repeat authors.  This is understating the
achievement a little - [one
person](../authors.html#Brian_Westley) has won 8 times
before! (Please note that judging is done completely anonymously.)


## Why has it taken so long to post the winning source?

This is somewhat my (Simon Cooper's) fault.  I do apologize to the IOCCC
community for this!  Judging does take quite a lot of time, and I
over-committed myself several times this year.  Without divulging too much,
we do look at and work out what every entry does.


## Final Comments

Please send us comments and suggestions what we have expressed above.
Also include anything else that you would like to see in future contests.
Send such email to:

```
    questions@ioccc.org
```

**IMPORTANT NOTE**: The email addresses found above are for historical
purposes only, and should not be used today.  See
[contact.html](../contact.html) for up to date contact details
as well as details on how to provide fixes to any of the entries.
See also the [IOCCC FAQ](../faq.html) for additional information on the IOCCC.


<!--

    Copyright © 1984-2024 by Landon Curt Noll. All Rights Reserved.

    You are free to share and adapt this file under the terms of this license:

        Creative Commons Attribution-ShareAlike 4.0 International (CC BY-SA 4.0)

    For more information, see:

        https://creativecommons.org/licenses/by-sa/4.0/

-->
